﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Text.RegularExpressions;
using System.IO;
using System.Net;
using System.Diagnostics;

namespace aukrowrapper
{
  public partial class Form1 : Form
  {
    const string baseURL = "http://www.aukro.cz";

    public Form1()
    {
      InitializeComponent();
    }

    private void button1_Click(object sender, EventArgs e)
    {
      label1.Text = "Inicializace...";
      label1.Refresh();

      inicializace();

      Thread hlidaci_pes = new Thread(new ThreadStart(maxipes_fik));
      hlidaci_pes.IsBackground = true;
      hlidaci_pes.Start();
    }


    void maxipes_fik()
    {
      //Group 1 - Nazev
      //Group 2 - Pocet
      Regex main_menu = new Regex(@"<h1 class=""bold small inline"">([^<]+)</h1> <span class=""smaller bold"">([^>]+)</span>");

      //Grouo 1 - Odkaz
      Regex odkaz_submenu = new Regex(@"<h3 class=""inline""><a href=""([^""]+)""");

      //Group 1 - Nazev
      //Group 2 - Pocet
      Regex submenu = new Regex(@"<span>([^<]+)</span></a></h3> <span class=""smaller"">([^<]+)</span>");


      HttpWebRequest req;
      WebResponse res;
      StreamReader read;
      string radek;
      bool issubmenu = false;
      string nazev;
      int pocet;
      List<PolozkaMenu> polozkytmp;
      PolozkaMenu tmp;
      int polozkaindex;
      //nekonenca smyka
      while (true)
      {
        try
        {
          label1.Text = "Hlidam...";
          
          req = (HttpWebRequest)WebRequest.Create(textBox1.Text);
          res = req.GetResponse();
          read = new StreamReader(res.GetResponseStream());
          polozkytmp = new List<PolozkaMenu>();

          while (!read.EndOfStream)
          {
            radek = read.ReadLine();

            #region Polozky v menu
            if (main_menu.IsMatch(radek))
            {
              nazev = main_menu.Split(radek)[1];
              pocet = Convert.ToInt32(main_menu.Split(radek)[2].Replace("(", "").Replace(")", "").Trim());
              progressBar1.Maximum = pocet;
              if (listBox1.Items.Cast<PolozkaMenu>().Where(x => x.Nazev == nazev).Select(y => y.Pocet).FirstOrDefault() < pocet)
              {
                reloadItems(nazev);
                polozkaindex = listBox1.Items.IndexOf(listBox1.Items.Cast<PolozkaMenu>().Where(x => x.Nazev == nazev).FirstOrDefault());
                tmp = ((PolozkaMenu)listBox1.Items[polozkaindex]);
                tmp.Pocet = pocet;
                listBox1.Items.RemoveAt(polozkaindex);
                listBox1.Items.Insert(polozkaindex, tmp);
                
                listBox1.Invalidate();
              }
              continue;
            }

            if (issubmenu && submenu.IsMatch(radek))
            {
              nazev = submenu.Split(radek)[1];
              pocet = Convert.ToInt32(submenu.Split(radek)[2].Replace("(", "").Replace(")", "").Trim());
              progressBar1.Maximum = pocet;
              if (listBox1.Items.Cast<PolozkaMenu>().Where(x => x.Nazev == nazev).Select(y => y.Pocet).FirstOrDefault() < pocet)
              {
                reloadItems(nazev);
                polozkaindex = listBox1.Items.IndexOf(listBox1.Items.Cast<PolozkaMenu>().Where(x => x.Nazev == nazev).FirstOrDefault());
                tmp = ((PolozkaMenu)listBox1.Items[polozkaindex]);
                tmp.Pocet = pocet;
                listBox1.Items.RemoveAt(polozkaindex);
                listBox1.Items.Insert(polozkaindex, tmp);
              }
              issubmenu = false;
              continue;
            }

            if (odkaz_submenu.IsMatch(radek))
            {
              issubmenu = true;
              continue;
            }
            #endregion
          }//while eos


          
        } 
        catch { }

        //5sec dame pauzu
        Thread.Sleep(5000);
      }//while 
    }

    private void reloadItems(string catName)
    {
      label1.Text = "Zmena detekovana v " + catName;
      Dictionary<string, string> tmpList = new Dictionary<string, string>();

      //Group 1 - Odkaz
      //Group 2 - Nazev
      Regex polozka = new Regex(@"<a href=""([^""]+)"" class=""iImg"" data-img=""[^""]+"" title=""([^""]+)""></a>");

      //Group 1 - Odkaz na dalsi vypis kategorie
      Regex Dalsi = new Regex(@"<a href=""([^""]+)"" class=""arrRight"" title=""Další""></a>");


      string radek = String.Empty;
      StreamReader read = null;
      bool hasNextPage = true;
      string NextPage = listBox1.Items.Cast<PolozkaMenu>().Where(x => x.Nazev == catName).Select(y => y.Odkaz).FirstOrDefault();

      try
      {
        progressBar1.Value = 0;
        HttpWebRequest req;
        WebResponse res;

        while (hasNextPage)
        {
          progressBar1.Refresh();
          //dalsi uz nemusi bejt

          hasNextPage = false;

          //nacteni prvni strany podkategorie
          req = (HttpWebRequest)WebRequest.Create(baseURL + NextPage);
          res = req.GetResponse();
          read = new StreamReader(res.GetResponseStream());

          while (!read.EndOfStream)
          {
            radek = read.ReadLine();

            if (polozka.IsMatch(radek))
            {
              try
              {
                progressBar1.Value++;
                progressBar1.Refresh();
                tmpList.Add(polozka.Split(radek)[1], polozka.Split(radek)[2]);
              }
              catch { }
            }

            if (Dalsi.IsMatch(radek))
            {
              hasNextPage = true;
              NextPage = Dalsi.Split(radek)[1];
            }
          } //EOS

          read.Close();
          res.Close();
        }//while nextpage

        var prunik = tmpList.Where(x => tmpList.Keys.Except(listBox1.Items.Cast<PolozkaMenu>().Where(xx => xx.Nazev == catName).Select(y => y.Polozky).FirstOrDefault().Keys).Contains(x.Key));
        foreach (var item in prunik)
          listBox2.Items.Add(item);

        listBox1.Items.Cast<PolozkaMenu>().Where(x => x.Nazev == catName).Select(y => y.Polozky).FirstOrDefault().Clear();

        //rebuild tree
        foreach (KeyValuePair<string, string> p in tmpList)
          listBox1.Items.Cast<PolozkaMenu>().Where(x => x.Nazev == catName).Select(y => y.Polozky).FirstOrDefault().Add(p.Key, p.Value);

      }

      catch { }
    }

    /// <summary>
    /// Prvotni natazeni vsech polozek a kategorii
    /// </summary>
    private void inicializace()
    {

      string hlavnimenuURL = textBox1.Text;
      //Group 1 - Nazev
      //Group 2 - Pocet
      Regex main_menu = new Regex(@"<h1 class=""bold small inline"">([^<]+)</h1> <span class=""smaller bold"">([^>]+)</span>");

      //Grouo 1 - Odkaz
      Regex odkaz_submenu = new Regex(@"<h3 class=""inline""><a href=""([^""]+)""");

      //Group 1 - Nazev
      //Group 2 - Pocet
      Regex submenu = new Regex(@"<span>([^<]+)</span></a></h3> <span class=""smaller"">([^<]+)</span>");

      //Group 1 - Odkaz
      //Group 2 - Nazev
      Regex polozka = new Regex(@"<a href=""([^""]+)"" class=""iImg"" data-img=""[^""]+"" title=""([^""]+)""></a>");

      //Group 1 - Odkaz na dalsi vypis kategorie
      Regex Dalsi = new Regex(@"<a href=""([^""]+)"" class=""arrRight"" title=""Další""></a>");



      bool issubmenu = false;
      string radek = String.Empty;
      StreamReader read = null;
      bool hasNextPage = false;
      string NextPage = String.Empty;


      try
      {
        //read = File.OpenText("C:\\aukro");
        HttpWebRequest req = (HttpWebRequest)WebRequest.Create(hlavnimenuURL);
        WebResponse res = req.GetResponse();
        read = new StreamReader(res.GetResponseStream());


        PolozkaMenu tmp = new PolozkaMenu();

        label1.Text = "Inicializace... Nahravam Hlavni kategorie";
        label1.Refresh();
        #region Hlavni Kategorie
        while (!read.EndOfStream)
        {
          radek = read.ReadLine();

          #region Polozky v menu
          if (main_menu.IsMatch(radek))
          {
            tmp = new PolozkaMenu();
            tmp.Polozky = new Dictionary<string, string>();
            tmp.Nazev = main_menu.Split(radek)[1];
            tmp.Pocet = Convert.ToInt32(main_menu.Split(radek)[2].Replace("(", "").Replace(")", "").Trim());
            tmp.Odkaz = hlavnimenuURL;
            listBox1.Items.Add(tmp);
            progressBar1.Maximum = tmp.Pocet;
            progressBar1.Value = 0;
            continue;
          }

          if (issubmenu && submenu.IsMatch(radek))
          {
            if (tmp == null)
              continue;

            tmp.Nazev = submenu.Split(radek)[1];
            tmp.Pocet = Convert.ToInt32(submenu.Split(radek)[2].Replace("(", "").Replace(")", "").Trim());

            listBox1.Items.Add(tmp);
            issubmenu = false;
            continue;
          }

          if (odkaz_submenu.IsMatch(radek))
          {
            tmp = new PolozkaMenu();
            tmp.Polozky = new Dictionary<string, string>();
            tmp.Odkaz = odkaz_submenu.Split(radek)[1].Trim();
            issubmenu = true;
            continue;
          }
          #endregion

          if (polozka.IsMatch(radek))
          {
            listBox1.Items.Cast<PolozkaMenu>().Where(x => x.Odkaz == hlavnimenuURL).FirstOrDefault().Polozky.Add(polozka.Split(radek)[1], polozka.Split(radek)[2]);
            progressBar1.Value++;
            progressBar1.Refresh();
          }

          if (Dalsi.IsMatch(radek))
          {
            hasNextPage = true;
            NextPage = Dalsi.Split(radek)[1];
          }
        }

        //Uzavru posledni spojeni
        read.Close();
        res.Close();
        progressBar2.Maximum = listBox1.Items.Count;
        progressBar2.Value = 0;
        #endregion

        #region Hlavni strana - dalsi stranky
        label1.Text = "Inicializace... Nahravam Dalsi strany hlavni kategorie";
        label1.Refresh();

        while (hasNextPage)
        {
          //download next page
          req = (HttpWebRequest)WebRequest.Create(baseURL + NextPage);
          res = req.GetResponse();
          read = new StreamReader(res.GetResponseStream());

          while (!read.EndOfStream)
          {
            hasNextPage = false;
            radek = read.ReadLine();
            if (polozka.IsMatch(radek))
            {
              try
              {
                progressBar1.Value++;
                progressBar1.Refresh();
                listBox1.Items.Cast<PolozkaMenu>().Where(x => x.Odkaz == hlavnimenuURL).FirstOrDefault().Polozky.Add(polozka.Split(radek)[1], polozka.Split(radek)[2]);
              }
              catch
              {

              }
            }

            if (Dalsi.IsMatch(radek))
            {
              hasNextPage = true;
              NextPage = Dalsi.Split(radek)[1];
            }
          }
          //Uzavru podtranky stranku
          read.Close();
          res.Close();
        }
        #endregion

        #region nacteni polozek podkategorii

        foreach (PolozkaMenu pol in listBox1.Items)
        {
          //pokud menu polozky, tak je to zrejme hlavni menu, jdu dal
          if (pol.Polozky.Count > 0)
          {
            progressBar2.Value++;
            continue;
          }

          label1.Text = "Inicializace... Nahravam polozky kategorie " + pol.Nazev;
          label1.Refresh();


          hasNextPage = true; //prvni strana existuje snad vzdy (kdyz ne, tak bude nula polozek)
          NextPage = pol.Odkaz; //prvni "dalsi" strana je prvni strana z kategorie
          progressBar1.Maximum = pol.Pocet;
          progressBar1.Value = 0;

          while (hasNextPage)
          {
            progressBar1.Refresh();
            //dalsi uz nemusi bejt

            hasNextPage = false;

            //nacteni prvni strany podkategorie
            req = (HttpWebRequest)WebRequest.Create(baseURL + NextPage);
            res = req.GetResponse();
            read = new StreamReader(res.GetResponseStream());

            while (!read.EndOfStream)
            {
              radek = read.ReadLine();

              if (polozka.IsMatch(radek))
              {
                try
                {
                  progressBar1.Value++;
                  progressBar1.Refresh();
                  listBox1.Items.Cast<PolozkaMenu>().Where(x => x.Odkaz == pol.Odkaz).FirstOrDefault().Polozky.Add(polozka.Split(radek)[1], polozka.Split(radek)[2]);
                }
                //jedine vysvetleni, proc progressbar pretece na value, je, ze nekdo pridal neco v prubehu inicializace, bude to tedy ve zmene v hlidacim psoj
                catch { }

              }

              if (Dalsi.IsMatch(radek))
              {
                hasNextPage = true;
                NextPage = Dalsi.Split(radek)[1];
              }
            } //EOS

            read.Close();
            res.Close();
          }

          progressBar2.Value++;
        } //ForEach

        #endregion

      } //TRY

      catch (Exception ex)
      {

      }
      finally
      {
        if (read != null)
          read.Close();
      }

    }

    private void button2_Click(object sender, EventArgs e)
    {
      listBox2.Items.Clear();
    }

    private void listBox2_DoubleClick(object sender, EventArgs e)
    {
      if (listBox2.SelectedIndex == -1)
        return;

      Process.Start(baseURL+((KeyValuePair<string, string>)listBox2.SelectedItem).Key);
    }

  }
}
